// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/cisco-open/kubei/api/client/models"
)

// GetVulnerabilitiesReader is a Reader for the GetVulnerabilities structure.
type GetVulnerabilitiesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetVulnerabilitiesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetVulnerabilitiesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewGetVulnerabilitiesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetVulnerabilitiesOK creates a GetVulnerabilitiesOK with default headers values
func NewGetVulnerabilitiesOK() *GetVulnerabilitiesOK {
	return &GetVulnerabilitiesOK{}
}

/* GetVulnerabilitiesOK describes a response with status code 200, with default header values.

Success
*/
type GetVulnerabilitiesOK struct {
	Payload *GetVulnerabilitiesOKBody
}

func (o *GetVulnerabilitiesOK) Error() string {
	return fmt.Sprintf("[GET /vulnerabilities][%d] getVulnerabilitiesOK  %+v", 200, o.Payload)
}
func (o *GetVulnerabilitiesOK) GetPayload() *GetVulnerabilitiesOKBody {
	return o.Payload
}

func (o *GetVulnerabilitiesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetVulnerabilitiesOKBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetVulnerabilitiesDefault creates a GetVulnerabilitiesDefault with default headers values
func NewGetVulnerabilitiesDefault(code int) *GetVulnerabilitiesDefault {
	return &GetVulnerabilitiesDefault{
		_statusCode: code,
	}
}

/* GetVulnerabilitiesDefault describes a response with status code -1, with default header values.

unknown error
*/
type GetVulnerabilitiesDefault struct {
	_statusCode int

	Payload *models.APIResponse
}

// Code gets the status code for the get vulnerabilities default response
func (o *GetVulnerabilitiesDefault) Code() int {
	return o._statusCode
}

func (o *GetVulnerabilitiesDefault) Error() string {
	return fmt.Sprintf("[GET /vulnerabilities][%d] GetVulnerabilities default  %+v", o._statusCode, o.Payload)
}
func (o *GetVulnerabilitiesDefault) GetPayload() *models.APIResponse {
	return o.Payload
}

func (o *GetVulnerabilitiesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetVulnerabilitiesOKBody get vulnerabilities o k body
swagger:model GetVulnerabilitiesOKBody
*/
type GetVulnerabilitiesOKBody struct {

	// List of vulnerabilities in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.Vulnerability `json:"items"`

	// Total vulnerabilities count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get vulnerabilities o k body
func (o *GetVulnerabilitiesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetVulnerabilitiesOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getVulnerabilitiesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetVulnerabilitiesOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getVulnerabilitiesOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get vulnerabilities o k body based on the context it is used
func (o *GetVulnerabilitiesOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetVulnerabilitiesOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getVulnerabilitiesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetVulnerabilitiesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetVulnerabilitiesOKBody) UnmarshalBinary(b []byte) error {
	var res GetVulnerabilitiesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
